#pragma GCC optimize ("Ofast")
#include<bits/stdc++.h>
#define endl "\n"
using namespace std;

int const MAXN=501, inf = 1e9;
int n, m, path[MAXN][MAXN], used[MAXN][MAXN], level[MAXN][MAXN];
char ch;

struct edge
{
    int x, y;
};

vector<edge> v;
edge p, c;

void fill_level(int row, int col, int lvl)
{
    level[row][col] = lvl;
    if(row < n && level[row+1][col] > lvl+1)
    {
        fill_level(row+1, col, lvl+1);
    }
    if(col < m && level[row][col+1] > lvl + 1)
    {
        fill_level(row, col+1, lvl+1);
    }
    if(row > 1 && level[row-1][col] > lvl + 1)
    {
        fill_level(row-1, col, lvl+1);
    }
    if(col > 1 && level[row][col-1] > lvl + 1)
    {
        fill_level(row, col-1, lvl+1);
    }
}

void fill_matrix(int row, int col, int val)
{
    path[row][col] = val;
    if(row < n && path[row+1][col] > val + 1)
    {
        fill_matrix(row+1, col, val+1);
    }
    if(col < m && path[row][col+1] > val + 1)
    {
        fill_matrix(row, col+1, val+1);
    }
    if(row > 1 && path[row-1][col] > val + 1)
    {
        fill_matrix(row-1, col, val+1);
    }
    if(col > 1 && path[row][col-1] > val + 1)
    {
        fill_matrix(row, col-1, val+1);
    }
}

bool solution(int row, int col, int val)
{
    //cout<<row<<" "<<col<<" "<<val<<endl;
    used[row][col] = 1;
    if(row == c.x && col == c.y)
    {
        return true;
    }
    if(!used[row+1][col] && row < n && path[row+1][col] >= val)
    {
        if(solution(row+1, col, val)) return true;
    }
    if(!used[row][col+1] && col < m && path[row][col+1] >= val)
    {
        if(solution(row, col+1, val)) return true;
    }
    if(!used[row-1][col] && row > 1 && path[row-1][col] >= val)
    {
        if(solution(row-1, col, val)) return true;
    }
    if(!used[row][col-1] && col > 1 && path[row][col-1] >= val)
    {
        if(solution(row, col-1, val)) return true;
    }
    if(row == p.x && col == p.y) return false;
}

void read()
{

    cin>>n>>m;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            cin>>ch;
            if(ch == '+')  v.push_back({i, j});
            else if(ch == 'P') p = {i, j};
            else if(ch == 'C') c = {i, j};
        }
    }
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            path[i][j] = inf;
            level[i][j] = inf;
        }
    }
    int sz = v.size();
    for(int i=0;i<sz;i++)
    {
        fill_matrix(v[i].x, v[i].y, 0);
    }
    //fill_level(c.x, c.y, 1);
    for(int u=min(path[p.x][p.y], path[c.x][c.y]);u>=1;u--)
    {
        if(solution(p.x, p.y, u))
        {
            cout<<u<<endl;
            return;
        }
        for(int i=1;i<=n;i++)
        {
            for(int j=1;j<=m;j++)
            {
                used[i][j] = 0;
            }
        }
    }
    cout<<0<<endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
