#pragma GCC optimize ("Ofast")
#include<bits/stdc++.h>
#define endl "\n"
using namespace std;

int const MAXN=1001, inf = 1e9;
int n, m, path[MAXN][MAXN], used[MAXN][MAXN];
char ch;

struct edge
{
    int x, y;
};

vector<edge> v;
edge p, c;

void fill_matrix(int row, int col, int val)
{
    path[row][col] = val;
    if(row < n && path[row+1][col] > val + 1)
    {
        fill_matrix(row+1, col, val+1);
    }
    if(col < m && path[row][col+1] > val + 1)
    {
        fill_matrix(row, col+1, val+1);
    }
    if(row > 1 && path[row-1][col] > val + 1)
    {
        fill_matrix(row-1, col, val+1);
    }
    if(col > 1 && path[row][col-1] > val + 1)
    {
        fill_matrix(row, col-1, val+1);
    }
}

bool check(int row, int col, int val)
{
    used[row][col] = 1;
    if(row == c.x && col == c.y)
    {
        return true;
    }
    if(!used[row+1][col] && row < n && path[row+1][col] >= val)
    {
        if(check(row+1, col, val)) return true;
    }
    if(!used[row][col+1] && col < m && path[row][col+1] >= val)
    {
        if(check(row, col+1, val)) return true;
    }
    if(!used[row-1][col] && row > 1 && path[row-1][col] >= val)
    {
        if(check(row-1, col, val)) return true;
    }
    if(!used[row][col-1] && col > 1 && path[row][col-1] >= val)
    {
        if(check(row, col-1, val)) return true;
    }
    if(row == p.x && col == p.y) return false;
}

int bin_search()
{
    int l = 0, r = min(path[p.x][p.y], path[c.x][c.y]);
    while(l <= r)
    {
        int mid = (l+r)/2;
        if(check(p.x, p.y, mid)) l = mid+1;
        else r = mid-1;
        for(int i=1;i<=n;i++)
        {
            for(int j=1;j<=m;j++)
            {
                used[i][j] = 0;
            }
        }
    }
    return r;
}

void read()
{

    cin>>n>>m;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            cin>>ch;
            if(ch == '+')  v.push_back({i, j});
            else if(ch == 'P') p = {i, j};
            else if(ch == 'C') c = {i, j};
        }
    }
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            path[i][j] = inf;
        }
    }
    int sz = v.size();
    for(int i=0;i<sz;i++)
    {
        fill_matrix(v[i].x, v[i].y, 0);
    }
    cout<<bin_search()<<endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}